<template>
  <t-button
    v-ripple="rippleColor"
    :to="to"
    :variant="variant"
    :variants="tButtonStyle.variants"
    :classes="tButtonStyle.classes"
    :fixed-classes="tButtonStyle.fixedClasses"
    :disabled="disabled"
    :type="type"
    :class="`
      text-${textAlign}
      ${fluid ? 'w-full' : ''}
      ${inline ? 'inline-block' : 'block'}
      ${classes}
      ${pill ? 'rounded-full' : 'rounded-md'}
    `"
  >
    <div
      :class="[
        'flex',
        'items-center',
        'gap-2'
      ]"
    >
      <!-- Slot for left icon -->
      <slot
        v-if="icon && iconPosition === 'left'"
        name="icon"
      >
        <v-icon
          v-bind="{
            name: icon,
            ...iconProps
          }"
        />
      </slot>
      <!-- Default slot -->
      <slot name="default" />
      <!-- Slot for right icon -->
      <slot
        v-if="icon && iconPosition === 'right'"
        name="icon"
      >
        <v-icon
          v-bind="{
            name: icon,
            ...iconProps
          }"
        />
      </slot>
    </div>
  </t-button>
</template>

<script>
// Color
// import Color from 'color'
// Mixins
import { Variantable, VariantableOptions } from '@/mixins/variantable'
// Component style
import Style from './style'

/**
 * Button component
 * @global
 */
export default {
  name: 'VButton',
  mixins: [
    Variantable
  ],
  props: {
    /**
     * 'To', if button is a router-link
     */
    to: {
      type: [ String, Object ],
      default: undefined
    },
    /**
     * Pill format ?
     */
    pill: {
      type: Boolean,
      default: false
    },
    /**
     * Define text alignment
     */
    textAlign: {
      type: String,
      default: 'center'
    },
    /**
     * Classes to add to the t-button
     */
    classes: {
      type: String,
      default: ''
    },
    /**
     * Type to add to the t-button
     */
    type: {
      type: String,
      default: 'button'
    },
    /**
     * Define if button is full width
     */
    fluid: {
      type: Boolean,
      default: false
    },
    /**
     * Define if button is disabled
     */
    disabled: {
      type: Boolean,
      default: false
    },
    /**
     * Define if button is displayed as inline-block
     */
    inline: {
      type: Boolean,
      default: false
    },
    /**
     * The icon name
     */
    icon: {
      type: String,
      default () {
        return undefined
      }
    },
    /**
     * Determines the icon position (left or right)
     */
    iconPosition: {
      type: String,
      default () {
        return 'left'
      }
    },
    /**
     * The props to pass to the icon component
     */
    iconProps: {
      type: Object,
      default () {
        return {
          class: {
            'fill-current': true
          },
          style: {
            maxHeight: '13px'
          }
        }
      }
    }
  },
  computed: {
    /**
     * ⚠ We have to return css classes as array because vue-tailwind TButton component
     * does not accept classes as object
     */
    tButtonStyle () {
      return new VariantableOptions(this.overriddenStyle, { cssClassesFormat: 'array' })
    },
    /**
     * Generate ripple color based on this.computedVariant
     */
    rippleColor: function () {
      let rippleColor
      switch (this.variant) {
        default:
          rippleColor = 'rgba(255, 255, 255, 0.05)'
          break
      }
      return rippleColor
    }
  },
  // Style for variantable
  style: Style
}
</script>
